/*
 * Output command-line help to stdout.
 *
 * Copyright 2004 Andrew Wood, distributed under the Artistic License.
 */

#include "config.h"
#include <stdio.h>


/*
 * Display command-line help.
 */
void display_help(void)
{
	printf(_("Usage: %s [OPTION]..."), PROGRAM_NAME);
	printf("\n%s\n\n",
	       _
	       ("Read the message on standard input and output it with an X-Spam header\n"
		"if it is spam."));
#ifdef HAVE_GETOPT_LONG
	printf("  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n"
	       "  %s\n" "  %s\n" "\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n"
	       "\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n"
	       "\n" "  %s\n" "  %s\n" "  %s\n" "\n",
	       _("-d,--database FILE    use FILE as a database"),
	       _
	       ("-g,--global FILE      use FILE as global (readonly) database"),
	       _
	       ("-s,--subject          add \"[SPAM]\" to Subject: of spam"),
	       _("-S,--subject-marker X add \"X\" instead of \"[SPAM]\""),
	       _("-n,--no-header        do not add X-Spam header to spam"),
	       _
	       ("-r,--add-rating       add an X-Spam-Rating header (0-100, 90+ = spam)"),
	       _
	       ("-t,--test             do not filter, just test for spam"),
	       _("-a,--allowlist        enable the allow-list"),
	       _
	       ("-T,--train SPAM NON   train database using SPAM and NON mbox folders"),
	       _
	       ("-m,--mark-spam        mark incoming message as spam in the database"),
	       _
	       ("-M,--mark-nonspam     mark incoming message as non-spam in the database"),
	       _
	       ("-w,--weight WEIGHT    mark message with weighting of WEIGHT instead of 1"),
	       _
	       ("-p,--prune,--trim     remove redundant entries from the database"),
	       _("-D,--dump             dump database as text"),
	       _("-R,--restore          restore database from text"),
	       _("-O,--tokens           list tokens found in a message"),
	       _
	       ("-E,--merge OTHERDB    merge OTHERDB into current database"),
	       _
	       ("-B,--benchmark A B    test training mode with mbox A and B (spam/non)"),
	       _("-h,--help             show this help and exit"),
	       _
	       ("-l,--license          show the license this program is distributed under"),
	       _
	       ("-V,--version          show version information and exit"));
#else				/* !HAVE_GETOPT_LONG */
	printf("  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n"
	       "  %s\n" "  %s\n" "\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n"
	       "\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n" "  %s\n"
	       "\n" "  %s\n" "  %s\n" "  %s\n" "\n",
	       _("-d FILE      use FILE as a database"),
	       _("-g FILE      use FILE as global (readonly) database"),
	       _("-s           add \"[SPAM]\" to Subject: of spam"),
	       _("-S X         add \"X\" instead of \"[SPAM]\""),
	       _("-n           do not add X-Spam header to spam"),
	       _
	       ("-r           add an X-Spam-Rating header (0-100, 90+ = spam)"),
	       _("-t           do not filter, just test for spam"),
	       _("-a           enable the allow-list"),
	       _
	       ("-T SPAM NON  train database using SPAM and NON mbox folders"),
	       _
	       ("-m           mark incoming message as spam in the database"),
	       _
	       ("-M           mark incoming message as non-spam in the database"),
	       _
	       ("-w WEIGHT    mark message with weighting of WEIGHT instead of 1"),
	       _
	       ("-p           remove redundant entries from the database"),
	       _("-D           dump database as text"),
	       _("-R           restore database from text"),
	       _("-O           list tokens found in a message"),
	       _("-E OTHERDB   merge OTHERDB into current database"),
	       _
	       ("-B A B       test training mode with mbox A and B (spam/non)"),
	       _("-h           show this help and exit"),
	       _
	       ("-l           show the license this program is distributed under"),
	       _("-V           show version information and exit"));
#endif				/* HAVE_GETOPT_LONG */
	printf(_("Please report any bugs to %s."), BUG_REPORTS_TO);
	printf("\n");
}

/* EOF */
